/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/

#include "stdafx.h"
#include "GetOSInfo.h"
#include "wbemcli.h"     // WMI interface declarations

static BOOL OSNameWmi(CString& OsName);

void FakeCFileDialog(CFileDialog &dlg)
{
	OSVERSIONINFO osvi;
	ZeroMemory(&osvi, sizeof(OSVERSIONINFO));
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx( &osvi );
	if( osvi.dwMajorVersion >= 5 ){
		dlg.m_ofn.lStructSize = sizeof(OPENFILENAME) + 12;
	}
}

void GetOSInfo(CString& OSName,CString& OSType,CString& OSCSD,CString& OSVersion,CString& OSBuild,CString& OSInfo)
{
	CString cstr;
	OSVERSIONINFOEX osvi;
	BOOL bOsVersionInfoEx;

	ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
	if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
	{
		osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
		GetVersionEx( (OSVERSIONINFO *) &osvi);
	}

	switch(osvi.dwPlatformId)
	{
	case VER_PLATFORM_WIN32_WINDOWS:

		switch( osvi.dwMinorVersion ){
		case 0: // Windows 95
			if( LOWORD(osvi.dwBuildNumber) < 1000 ){
				OSName = "Windows 95";	
			}else if( LOWORD(osvi.dwBuildNumber) >= 1214 ){
				OSName = "Windows 95 OSR2.5";
			}else if( LOWORD(osvi.dwBuildNumber) >= 1212 ){
				OSName = "Windows 95 OSR2.1";
			}else if( LOWORD(osvi.dwBuildNumber) == 1111 ){
				OSName = "Windows 95 OSR2";
			}else{
				OSName = "Windows 95";	
			}
			break;
		case 10: // Windows 98
			if( LOWORD(osvi.dwBuildNumber) == 1998 ){
				OSName = "Windows 98";	
			}else if( LOWORD(osvi.dwBuildNumber) >= 2222 ){
				OSName = "Windows 98 SE";
			}else if( LOWORD(osvi.dwBuildNumber) >= 2000 ){
				OSName = "Windows 98 SP1";
			}else{
				OSName = "Windows 98";	
			}
			break;
		case 90:
			OSName = "Windows Me";
			break;
		default:
			OSName = "Windows 9x";
			break;
		}

		OSVersion.Format("%d.%d",osvi.dwMajorVersion,osvi.dwMinorVersion);
		OSBuild.Format("%d",LOWORD(osvi.dwBuildNumber)); 
		break;

	case VER_PLATFORM_WIN32_NT:
		if(osvi.dwMajorVersion == 3){
			OSName.Format("Windows NT3.%d",osvi.dwMinorVersion);
		}else if(osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 0){
			OSName = "Windows NT4";
		}else if(osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 0){
			OSName = "Windows 2000";
		}else if(osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 1){
			OSName = "Windows XP";
		}else if(osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 2){
			OSName = "Windows Server 2003";
		}else if(osvi.dwMajorVersion == 6 && osvi.dwMinorVersion == 0){
			OSName = "Windows NT6.0 (Longhorn)";
		}else{
			OSName.Format("Windows NT%d.%d",osvi.dwMajorVersion,osvi.dwMinorVersion);
		}

//		if(! (osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 2) ){
			if( bOsVersionInfoEx ){
				if( osvi.wProductType == VER_NT_WORKSTATION ){
					if( osvi.wSuiteMask & VER_SUITE_PERSONAL ){
						OSType = "Home";
					}else{
						if(osvi.dwMajorVersion == 5){OSType = "Professional";}
						else if(osvi.dwMajorVersion == 4){OSType = "Workstation";}
					}
				}else if( osvi.wProductType == VER_NT_SERVER ){
					if( osvi.wSuiteMask & VER_SUITE_DATACENTER ){
						OSType = "DataCenter Server";
					}else if( osvi.wSuiteMask & VER_SUITE_ENTERPRISE ){
						OSType = "Advanced Server";
					}else{
						OSType = "Server";
					}
				}
			}else{// NT4 SP5
					HKEY hKey;
					char szProductType[80];
					DWORD dwBufLen;
					RegOpenKeyEx( HKEY_LOCAL_MACHINE,
						"SYSTEM\\CurrentControlSet\\Control\\ProductOptions",
						0, KEY_QUERY_VALUE, &hKey );
					RegQueryValueEx( hKey, "ProductType", NULL, NULL,
						(LPBYTE) szProductType, &dwBufLen);
					RegCloseKey( hKey );
					if( lstrcmpi( "WINNT", szProductType) == 0 ){OSType = "Workstation";}
					if( lstrcmpi( "LANMANNT", szProductType) == 0 ){OSType = "Server";}
					if( lstrcmpi( "SERVERNT", szProductType) == 0 ){OSType = "Advanced Server";}
			 }
//		}

		// for x86-64
		if( osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 2 ){
			OSNameWmi(cstr);
			if( cstr.Find("XP") != -1 ){
				OSName = "Windows XP";
				OSType = "Professional";
			}
		}

		OSCSD = osvi.szCSDVersion;
		//OSCSD.Replace("Service Pack ","SP");

		OSVersion.Format("%d.%d",osvi.dwMajorVersion,osvi.dwMinorVersion);
		OSBuild.Format("%d",osvi.dwBuildNumber);
				 
		break;
	}
	if( ! OSCSD.IsEmpty() ){
		OSInfo = OSName + " " + OSCSD;
	}else{
		OSInfo = OSName;
	}
}


typedef HRESULT(WINAPI * _CoInitializeSecurity_)(PSECURITY_DESCRIPTOR pVoid,LONG cAuthSvc,SOLE_AUTHENTICATION_SERVICE * asAuthSvc,void * pReserved1,
DWORD dwAuthnLevel,DWORD dwImpLevel,SOLE_AUTHENTICATION_LIST * pAuthList,DWORD dwCapabilities,void * pReserved3);

static BOOL OSNameWmi(CString& OsName)
{
	try{
		HRESULT hRes = S_OK;
		DWORD uReturned = 1;

		IWbemLocator *pIWbemLocator = NULL;
		IWbemServices* pIWbemServices = NULL;
		IEnumWbemClassObject *pEnumCOMDevs = NULL;
		IWbemClassObject  *pCOMDev = NULL;

		CoInitialize( NULL );

		_CoInitializeSecurity_ CoInitializeSecurity = NULL;
		HINSTANCE hDLL = LoadLibrary( "ole32.dll" );
		if(  hDLL != NULL ){
			CoInitializeSecurity = (_CoInitializeSecurity_)GetProcAddress( hDLL, "CoInitializeSecurity" );
		}
		if(CoInitializeSecurity == NULL){
			FreeLibrary(hDLL);
			return FALSE;
		}
		CoInitializeSecurity(NULL, -1, NULL, NULL,
			RPC_C_AUTHN_LEVEL_PKT_PRIVACY,RPC_C_IMP_LEVEL_IMPERSONATE,
			NULL,EOAC_SECURE_REFS,NULL );
		FreeLibrary(hDLL);

		if( CoCreateInstance(CLSID_WbemLocator,NULL,
			CLSCTX_INPROC_SERVER,IID_IWbemLocator,
			(LPVOID *) &pIWbemLocator) != S_OK ){return FALSE;}
		if( pIWbemLocator->ConnectServer(SysAllocString(L"\\\\.\\root\\cimv2"),
			NULL,NULL,0L,0L,NULL,NULL,&pIWbemServices) != S_OK ){return FALSE;}
		pIWbemLocator->Release();

	/////////////////
	// OS
		pIWbemServices->ExecQuery(SysAllocString(L"WQL"),
		SysAllocString(L"select Caption,Version,CSDVersion,InstallDate from Win32_OperatingSystem"),0,NULL,&pEnumCOMDevs);
		if( SUCCEEDED( pEnumCOMDevs->Next(2000,1,&pCOMDev,&uReturned )) && uReturned == 1){
			VARIANT  pVal;VariantClear(&pVal);
			if( pCOMDev->Get(L"Caption",0L,&pVal,NULL,NULL) == WBEM_S_NO_ERROR){
				OsName = pVal.bstrVal;
				OsName.Replace("Microsoft ","");
			}
			pCOMDev->Release();
		}
		if( pEnumCOMDevs ){pEnumCOMDevs->Release();pEnumCOMDevs = NULL;}
		if(pIWbemServices){pIWbemServices->Release();pIWbemServices = NULL;}
	}catch(...){
		return FALSE;
	}

	return TRUE;
}